/*
 * Copyright 2004-2006 the Seasar Foundation and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.seasar.teeda.core.context.servlet;

import java.util.Enumeration;

import javax.servlet.ServletRequest;

import org.seasar.teeda.core.context.AbstractExternalContextMap;

/**
 * @author Shinpei Ohtani
 */
public class ServletRequestMap extends AbstractExternalContextMap {

    private ServletRequest request_;

    public ServletRequestMap(ServletRequest request) {
        request_ = request;
    }

    protected Object getAttribute(String key) {
        return request_.getAttribute(key);
    }

    protected void setAttribute(String key, Object value) {
        request_.setAttribute(key, value);
    }

    protected Enumeration getAttributeNames() {
        return request_.getAttributeNames();
    }

    protected void removeAttribute(String key) {
        request_.removeAttribute(key);
    }

}
